;;;-*- Package: PVM; Syntax: Common-Lisp; Mode: Lisp -*-



;;; COmpiling C Files:

;;; cc -g -I../include -o lisp-slave lisp-slave.c ../lib/SUN4/libpvm3.a

;;; gcc -g -I/users/lothar/pvm3/include -o lisp-slave lisp-slave.c -L/users/lothar/pvm3/lib/SUN4SOL2 -lgpvm3 -lpvm3 -lnsl -lsocket

(defpackage pvm
  (:use "COMMON-LISP" "FF")
  (:export
;;;; pvm foreign functions
  "PVM_MYTID" 
	  ;;"PVM_ADVISE"
  "PVM_ADDHOSTS"
	  "PVM_BUFINFO"
	  "PVM_CONFIG"
	  "PVM_DELETE"
	  "PVM_DELHOSTS"
	  "PVM_EXIT"
	  "PVM_FREEBUF"
	  "PVM_GETRBUF"
	  "PVM_GETSBUF"
	  "PVM_HALT"
	  "PVM_INITSEND"
	  "PVM_INSERT"
	  "PVM_KILL"
	  "PVM_LOOKUP"
	  "PVM_MCAST"
	  "PVM_MKBUF"
	  "PVM_MSTAT"
	  "PVM_NOTIFY"
	  "PVM_NRECV"
	  "PVM_PARENT"
	  "PVM_PKBYTE"
	  "PVM_PKCPLX"
	  "PVM_PKDCPLX"
	  "PVM_PKDOUBLE"
	  "PVM_PKFLOAT"
	  "PVM_PKLONG"
	  "PVM_PKINT"
	  "PVM_PKSHORT"	
	  "PVM_PKSTR"
	  "PVM_PROBE"
	  "PVM_PSTAT"
	  "PVM_RECV"
	  "PVM_SEND"
	  "PVM_SETOPT"
	  "PVM_SENDSIG"
	  ;;"PVM_SERROR"
	  ;;"PVM_SETDEBUG"
	  "PVM_SETRBUF"
	  "PVM_SETSBUF"
	  "PVM_SPAWN"
	  "PVM_START_PVMD"
	  "PVM_TASKS"
	  "PVM_TICKLE"
	  "PVM_TIDTOHOST"
	  "PVM_UPKBYTE"
	  "PVM_UPKCPLX"
	  "PVM_UPKDCPLX"
	  "PVM_UPKDOUBLE"
	  "PVM_UPKFLOAT"
	  "PVM_UPKLONG"
	  "PVM_UPKSHORT"
	  "PVM_UPKINT"
	  "PVM_UPKSTR"
	  
;;;; pvm constants
	  "PVMDATADEFAULT"
	  "PVMDATARAW"
	  "PVMOK"
	  "PVMBADPARAM" 
	  "PVMMISMATCH" 
	  "PVMNODATA" 
	  "PVMNOHOST" 
	  "PVMNOFILE" 
	  "PVMNOMEM" 
	  "PVMBADMSG" 
	  "PVMSYSERR" 
	  "PVMNOBUF" 
	  "PVMNOSUCHBUF" 
	  "PVMNULLGROUP" 
	  "PVMDUPGROUP" 
	  "PVMNOGROUP" 
	  "PVMNOTINGROUP" 
	  "PVMNOINST" 
	  "PVMHOSTFAIL" 
	  "PVMNOPARENT" 
	  "PVMNOTIMPL" 
	  "PVMDSYSERR" 
	  "PVMBADVERSION" 
	  "PVMOUTOFRES" 
	  "PVMDUPHOST" 
	  "PVMCANTSTART" 
	  "PVMALREADY" 
	  "PVMNOTASK" 
	  "PVMNOENTRY" 
	  "PVMDUPENTRY"
	  "PVMROUTE"
	  "PVMROUTEDIRECT"
;;;; c-types needed to use the foreign functions
	  "HOSTINFO" 
	  "INTPOINT" 
	  "FLOATPOINT" 
	  "HOSTARRAY" 
	  "EMPTY-ARRAY"
	  "PIDS" 
	  "TMPINTPOINT" 
	  "TMPFLOATPOINT" 
	  "AINTPOINT"
;;;; the constructors for the types 
	  "MAKE-HOSTINFO" 
	  "MAKE-INTPOINT" 
	  "MAKE-FLOATPOINT" 
	  "MAKE-HOSTARRAY" 
	  "MAKE-EMPTY-ARRAY"
	  "MAKE-PIDS" 
	  "MAKE-TMPINTPOINT" 
	  "MAKE-TMPFLOATPOINT" 
	  "MAKE-AINTPOINT"
;;;; auxilliary usefull functions, methods ,and  macros 
	  "TO-FLOATPOINTER"
	  "TO-POINTER"
	  "POINTER-VALUE"
	  "WITH-PVM-COMMAND"
	  "CREATE_TASK")) 

(in-package pvm)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Laden des Foreign Function Package 

;;; cc -c -g -I/users/lothar/pvm3/include main-pvm.c ../lib/SUN4/libpvm3.a

;;; cc -c -g -I/users/lothar/pvm3/include -o $PVM_ARCH/main-pvm.o  main-pvm.c ~lothar/pvm3/lib/$PVM_ARCH/libpvm3.a 


;;; Mit -K pic gehts nicht:
;;; cc -c -K pic -g -I/users/lothar/pvm3/include -o $PVM_ARCH/main-pvm.o  main-pvm.c ~lothar/pvm3/lib/$PVM_ARCH/libpvm3.a 

;;; cc-ld main-pvm


;;; Mit -fPIC gehts auf SOL:
;;; gcc -c -g -I/users/lothar/pvm3/include -o svr4-objects/main-pvm.o -fPIC main-pvm.c 
;;; Und Laden von Libs in .so:
;;; ld -G -o $PVM_ARCH/main-pvm.so $PVM_ARCH/main-pvm.o -lpvm3 -lm -lnsl -lsocket -lgpvm3

#| ACHTUNG fuer SUNMP mit Thread Lib. Geht das?
;;; gcc -c -g -I/users/lothar/pvm3/include -o svr4-objects/main-pvm.o -fPIC main-pvm.c 
;;; Und Laden von Libs in .so:
;;; ld -G -o $PVM_ARCH/main-pvm.so $PVM_ARCH/main-pvm.o -lpvm3 -lm -lnsl -lsocket -lgpvm3 -lthread
|#

;;; cc-ld-sol main-pvm

#-PVM-LOADED
(format t "~%~%;   Laden der PVM-Objektfiles...~%~%")

#-PVM-LOADED
(progn
  #-svr4
  (load   "~hotz/star-source/disgral/pvminterface/SUN4/main-pvm.o"
		:foreign-files '("~lothar/pvm3/lib/SUN4/libpvm3.a")
		:system-libraries '("m" ))
  #+svr4
  (progn
    (load   "~hotz/star-source/disgral/pvminterface/SUN4SOL2/main-pvm.so")
    (format t "Laden PVM Utils~%")
    (load   "~hotz/star-source/disgral/pvminterface/SUN4SOL2/pvm-utils.so")))







;;; Lib: libgpvm3.a Wo ist sie? Dort sind die auskommentierten Fct.
;;;      drin!
#-PVM-LOADED
(progn
  #-svr4
   (load   ""
	:unreferenced-lib-names 
	'("_pvm_mytid" 
	  ;;"_pvm_advise"
	  "_pvm_addhosts"
	  "_pvm_bufinfo"
	  "_pvm_config"
	  "_pvm_delete"
	  "_pvm_delhosts"
	  "_pvm_exit"
	  "_pvm_freebuf"
	  "_pvm_getrbuf"
	  "_pvm_getsbuf"
	  "_pvm_halt"
	  "_pvm_initsend"
	  "_pvm_insert"
	  "_pvm_kill"
	  "_pvm_lookup"
	  "_pvm_mcast"
	  "_pvm_mkbuf"
	  "_pvm_mstat"
	  "_pvm_notify"
	  "_pvm_nrecv"
	  "_pvm_parent"
	  "_pvm_pkbyte"
	  "_pvm_pkcplx"
	  "_pvm_pkdcplx"
	  "_pvm_pkdouble"
	  "_pvm_pkfloat"
	  "_pvm_pklong"
	  "_pvm_pkshort"	
	  "_pvm_pkstr"
	  "_pvm_probe"
	  "_pvm_pstat"
	  "_pvm_recv"
	  "_pvm_send"
	  "_pvm_setopt"
	  "_pvm_sendsig"
	  ;;"_pvm_serror"
	  ;;"_pvm_setdebug"
	  "_pvm_setrbuf"
	  "_pvm_setsbuf"
	  "_pvm_spawn"
	  "_pvm_start_pvmd"
	  "_pvm_tasks"
	  "_pvm_tickle"
	  "_pvm_tidtohost"
	  "_pvm_upkbyte"
	  "_pvm_upkcplx"
	  "_pvm_upkdcplx"
	  "_pvm_upkdouble"
	  "_pvm_upkfloat"
	  "_pvm_upklong"
	  "_pvm_upkshort"
	  "_pvm_upkstr")
	:foreign-files '("~lothar/pvm3/lib/SUN4/libpvm3.a")
	:system-libraries '("m" )
	)
   #+svr4
   ;;; Nur pruefen, ob Funktionen vorhanden!
  (load   ""
	:unreferenced-lib-names 
	'("create_task"
	  
	  "pvm_mytid" 

	  "pvm_addhosts"
	  "pvm_bufinfo"
	  "pvm_config"
	  "pvm_delete"
	  "pvm_delhosts"
	  "pvm_exit"
	  "pvm_freebuf"
	  "pvm_getrbuf"
	  "pvm_getsbuf"
	  "pvm_halt"
	  "pvm_initsend"
	  "pvm_insert"
	  "pvm_kill"
	  "pvm_lookup"
	  "pvm_mcast"
	  "pvm_mkbuf"
	  "pvm_mstat"
	  "pvm_notify"
	  "pvm_nrecv"
	  "pvm_parent"
	  "pvm_pkbyte"
	  "pvm_pkcplx"
	  "pvm_pkdcplx"
	  "pvm_pkdouble"
	  "pvm_pkfloat"
	  "pvm_pklong"
	  "pvm_pkshort"	
	  "pvm_pkstr"
	  "pvm_probe"
	  "pvm_pstat"
	  "pvm_recv"
	  "pvm_send"
	  "pvm_setopt"
	  "pvm_sendsig"


	  "pvm_setrbuf"
	  "pvm_setsbuf"
	  "pvm_spawn"
	  "pvm_start_pvmd"
	  "pvm_tasks"
	  "pvm_tickle"
	  "pvm_tidtohost"
	  "pvm_upkbyte"
	  "pvm_upkcplx"
	  "pvm_upkdcplx"
	  "pvm_upkdouble"
	  "pvm_upkfloat"
	  "pvm_upklong"
	  "pvm_upkshort"
	  "pvm_upkstr")
	)
)

#-PVM-LOADED
(pushnew :pvm-loaded *features*)
#|
(load   ""
	:unreferenced-lib-names '(
	"_pvm_barrier"
	"_pvm_bcast"	
	"_pvm_getinst"
	"_pvm_gettid"
	"_pvm_gsize"

	"_pvm_joingroup"
	"_pvm_lvgroup"
	"_pvm_perror"
	"_pvm_pk"	
	"_pvm_upk"	
)
		:foreign-files '("~lothar/pvm3/lib/SUN4/libgpvm3.a")
		)
|#

#-PVM-LOADED
(format t "~%;   ...Laden beendet -- Definitionen der 'foreign Functions'")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



(format t ".")

;;; PVM UTILS

(defforeign 'create_task
    :entry-point (convert-to-lang "create_task")
    :arguments '(string string
		 integer string integer 
		 ;;; Tids werden als array returned!
		 (simple-array  fixnum (*)))
    :return-type :integer )



;;; PVM Internals
(defforeign 'pvm_mytid
    :entry-point (convert-to-lang "pvm_mytid")
    :arguments '() 
    :return-type :integer )

(defforeign 'pvm_parent
    :entry-point (convert-to-lang "pvm_parent")
    :return-type :integer )

(defforeign 'pvm_tidtohost
    :entry-point (convert-to-lang "pvm_tidtohost")
    :return-type :integer )

(defforeign 'pvm_exit
    :entry-point (convert-to-lang "pvm_exit")
    :arguments '() 
    :return-type :integer )

(defforeign 'pvm_pstat
    :entry-point (convert-to-lang "pvm_pstat")
    :arguments '(integer) 
    :return-type :integer )

(defforeign 'pvm_mstat
    :entry-point (convert-to-lang "pvm_mstat")
    :arguments '(string) 
    :return-type :integer )

(defforeign 'pvm_initsend
    :entry-point (convert-to-lang "pvm_initsend")
    :arguments '(integer) 
    :return-type :integer )

(defforeign 'pvm_pkint
    :entry-point (convert-to-lang "pvm_pkint")
    :arguments '((simple-array  fixnum (*)) integer integer) 
    :return-type :integer )

(defforeign 'pvm_upkint
    :entry-point (convert-to-lang "pvm_upkint")
    :arguments '((simple-array  fixnum (*)) integer integer) 
    :return-type :integer )

(defforeign 'pvm_pkfloat
    :entry-point (convert-to-lang "pvm_pkfloat")
    :arguments '((simple-array short-float (*)) integer integer) 
    :return-type :integer)



(defforeign 'pvm_upkfloat
    :entry-point (convert-to-lang "pvm_upkfloat")
    :arguments '((simple-array short-float (*)) integer integer) 
    :return-type :integer)

(defforeign 'pvm_pkstr
    :entry-point (convert-to-lang "pvm_pkstr")
    :arguments '(simple-string) 
    :return-type :integer)

(defforeign 'pvm_upkstr
    :entry-point (convert-to-lang "pvm_upkstr")
    :arguments '(simple-string) 
    :return-type :integer)

(defforeign 'pvm_mcast
    :entry-point (convert-to-lang "pvm_mcast")
    :arguments '((simple-array  fixnum (*)) integer integer) 
    :return-type :integer )

(defforeign 'pvm_recv
    :entry-point (convert-to-lang "pvm_recv")
    :arguments '(integer  integer) 
    :return-type :integer )

(defforeign 'pvm_nrecv
    :entry-point (convert-to-lang "pvm_nrecv")
    :arguments '(integer  integer) 
    :return-type :integer )

(defforeign 'pvm_probe
    :entry-point (convert-to-lang "pvm_probe")
    :arguments '(integer  integer) 
    :return-type :integer )

(defforeign 'pvm_send
    :entry-point (convert-to-lang "pvm_send")
    :arguments '(integer  integer) 
    :return-type :integer )

(defforeign 'pvm_setopt
    :entry-point (convert-to-lang "pvm_setopt")
    :arguments '(integer  integer) 
    :return-type :integer)

(defforeign 'pvm_bufinfo
    :entry-point (convert-to-lang "pvm_bufinfo")
    :arguments '(integer (simple-array  fixnum (*))
		 (simple-array  fixnum (*))
		 (simple-array  fixnum (*)))
    :return-type :integer  ;;;:void ;;;:integer 
    )

(defforeign 'pvm_kill 
    :entry-point (convert-to-lang "pvm_kill")
    :arguments '(integer)
    :return-type :integer)

;;; so laeuft addhost!
(defforeign 'pvm_addhosts
    :entry-point (convert-to-lang "pvm_addhosts")
    :arguments '((simple-array  simple-string (*)) integer  integer
		 ) 
    :pass-types '(:by-value :by-value :by-address )    
    :return-type :integer  ;;;:void ;;;:integer 
    )

(defforeign 'pvm_delhosts
    :entry-point (convert-to-lang "pvm_delhosts")
    :arguments '((simple-array  simple-string (*)) integer  integer) 
    :pass-types '(:by-value :by-value :by-address )    
    :return-type :integer)

(def-c-type (hostinfo :in-foreign-space) :struct
	    (hi_tid :int)
	    (*hi_name * :char)
	    (*hi_arch * :char)
	    (hi_speed :int))
#| pvm3.0
(def-c-type (hostinfo :in-foreign-space) :struct
	    (dtid :int)
	    (*host * :char)
	    (*arch * :char)
	    (max-packet :int)
	    (speed :int))
|#
			


#|
(defforeign 'pvm_config
    :entry-point (convert-to-lang "pvm_config")
    :arguments '((vector integer) (vector integer) t (vector simple-string)) 
    
    :return-type :integer )
|#
(def-c-type (intpoint :in-foreign-space) * :int)

(def-c-type (floatpoint :in-foreign-space) * :float)

(def-c-type (hostarray :in-foreign-space) 10 hostinfo)

;;;(def-c-type (hostp :in-foreign-space) * hostarray)

;;;(def-c-type (hostinfos :in-foreign-space) 3 hostinfo)

#|laeuft nicht
(defforeign 'pvm_config
    :entry-point (convert-to-lang "pvm_config")
    :arguments '((simple-array fixnum (1)) (simple-array fixnum (1)) integer)
    :pass-types '(:by-address :by-address :by-address )
    :return-type :integer)
|#
#|
(defforeign 'pvm_config
    :entry-point (convert-to-lang "pvm_config")
    :arguments '(integer integer integer)
    :pass-types '(:by-address :by-address :by-address )
    :return-type :integer)
|#

(defforeign 'pvm_config
    :entry-point (convert-to-lang "pvm_config")
    :arguments '(integer integer integer)
    :return-type :integer)

(defforeign 'pvm_config
    :entry-point (convert-to-lang "pvm_config")
    :arguments '((simple-array fixnum (*)) (simple-array fixnum (*)) 
		 (simple-array fixnum (*)))
    :return-type :integer)


#|	    
(defforeign 'pvm_spawn
    :entry-point (convert-to-lang "pvm_spawn")
    :arguments '(string (simple-array  simple-string (*)) integer string integer array) 
    :return-type :integer )

(defforeign 'pvm_spawn
    :entry-point (convert-to-lang "pvm_spawn")
    :arguments '(string (simple-array  simple-string (*)) integer string integer integer) 
    :return-type :integer )
|#
#|
(defforeign 'pvm_spawn
    :entry-point (convert-to-lang "pvm_spawn")
    :arguments '(string integer integer string integer integer) 
    :return-type :integer )
(defforeign 'pvm_spawn
    :entry-point (convert-to-lang "pvm_spawn")
    :return-type :integer )
|#


;;; so gehts
(defforeign 'pvm_spawn
    :entry-point (convert-to-lang "pvm_spawn")
    :arguments '(string integer integer string integer 
		 ;;; Tids werden als array returned!
		 (simple-array  fixnum (*)))
    :return-type :integer )

;;; so auch? jau!
(defforeign 'pvm_spawn
    :entry-point (convert-to-lang "pvm_spawn")
    :arguments '(string (simple-array  simple-string (*))
		 integer string integer 
		 ;;; Tids werden als array returned!
		 (simple-array  fixnum (*)))
    :return-type :integer )

;;;(def-c-type (empty-array :in-foreign-space) * 2 :char)
(def-c-type (empty-array :in-foreign-space) * 0 :char)


#|
(defun make-c-array (&optional (string "") &rest strings)
  (when (not (stringp string))
    (setq string (format nil "~S" string)))
  (make-array
   (+ ;;2
    1 (length strings)) :element-type 'string
   :initial-contents (append (cons string strings);; '("")
			     )))
|#

#|
(defun make-c-array (&optional (string "") &rest strings)
  (when (not (stringp string))
    (setq string (format nil "~S" string)))
  (eval `(def-c-type (string-array :in-foreign-space) * ,(1+ (length strings))
		     :char))
  (loop for string in (
  (make-string-array)
  (make-array
   (+ ;;2
    1 (length strings)) :element-type 'string
   :initial-contents (append (cons string strings);; '("")
			     )))
|#


(defun make-c-array (&optional (string "") &rest strings)
  (when (not (stringp string))
    (setq string (format nil "~S" string)))
  (make-array
   (+ ;;2
    1 (length strings)) :element-type 'string
   :initial-contents (cons string strings)))

(defun make-fixnum-array (size)
  (make-array size 
	      :element-type 'fixnum))

(defun make-single-float-array (size)
  (make-array size 
	      :element-type 'single-float))


;;;(def-c-type (tids :in-foreign-space) 100 :int)

(def-c-type (pids :in-foreign-space) * 0 :int)


(defconstant PvmDataDefault 0)
(defconstant PvmDataRaw 1)
(defconstant PvmOk 0)
(defconstant PvmBadParam -2)
(defconstant PvmMismatch -3)
(defconstant PvmNoData -5)
(defconstant PvmNoHost -6)
(defconstant PvmNoFile -7)
(defconstant PvmNoMem -10)
(defconstant PvmBadMsg -12)
(defconstant PvmSysErr -14)
(defconstant PvmNoBuf -15)
(defconstant PvmNoSuchBuf -16)
(defconstant PvmNullGroup -17)
(defconstant PvmDupGroup -18)
(defconstant PvmNoGroup -19)
(defconstant PvmNotInGroup -20)
(defconstant PvmNoInst -21)
(defconstant PvmHostFail -22)
(defconstant PvmNoParent -23)
(defconstant PvmNotImpl -24)
(defconstant PvmDSysErr -25)
(defconstant PvmBadVersion -26)
(defconstant PvmOutOfRes -27)
(defconstant PvmDupHost -28)
(defconstant PvmCantStart -29)
(defconstant PvmAlready -30)
(defconstant PvmNoTask -31)
(defconstant PvmNoEntry -32)
(defconstant PvmDupEntry -33)
(defconstant PvmRoute 1)
(defconstant PvmRouteDirect 3)


(def-c-type (tmpintpoint :in-foreign-space) 1 :int)

(def-c-type (tmpfloatpoint :in-foreign-space) 1 :float)

(defun to-floatpointer (float)
  (let ((i (make-tmpfloatpoint)))
    (setf (tmpfloatpoint i 0) float)
    i))

(defmethod to-pointer ((number integer))
  (make-array 1 :element-type 'fixnum :initial-element number))

(defmethod to-pointer ((number single-float))
  (make-array 1 :element-type 'short-float :initial-element number))

(defmethod pointer-value (to-pointer)
  (aref to-pointer 0))

(def-c-type (aintpoint :in-foreign-space) 32 :int)


;;; Mit conditions?



(defmacro with-pvm-command (&body body)
  (let ((result (gensym))
	(args (gensym)))
    ;;; Vorsicht hier werden Argumente 2mal evaluiiert
    (print body)
    `(let* ((,args (list ,@(cdar body)))
	    (,result (apply (fdefinition ',(caar body)) ,args)))
       (handle-pvm-result ,(intern (caar body) :keyword)
			  ,result
			  ,args))))
			  

     



(defmethod handle-pvm-result ((function (eql :create_task)) (result number)
			       callargs)
  (handle-pvm-result :pvm_spawn result callargs))


(defmethod handle-pvm-result ((function (eql :pvm_spawn)) 
			      (result (eql pvmbadparam))
			       callargs)
  (format t "~%Giving an invalid argument value in ~S~%" callargs))

(defmethod handle-pvm-result ((function (eql :pvm_spawn)) 
			      (result (eql pvmnohost))
			       callargs)
  (format t "~%Specified host is not in the virtual machine ~S~%" (second callargs)))

(defmethod handle-pvm-result ((function (eql :pvm_spawn)) 
			      (result t)
			       callargs)
  (format t "~%No Problem ~S~%" (second callargs)))


(defvar *root-task-p* :notset)

(defun root-task-p ()
  (cond ((eq *root-task-p* :notset)
	 (setq *root-task-p*
	   (let ((root-p (pvm_parent)))
	     (if (eq root-p PvmNoParent)
		 t
	       nil))))
	(t *root-task-p*)))




