(in-package nc)

(defclass my-vector (active-object distributable-object)
  ((content :accessor content 
 	    :initarg :content))
  (:metaclass distributable-object-class))

(defmethod add-up ((vec my-vector))
  (let* ((cont (content vec))
	 (length (length cont)))
    (cond ((< length 3) (print (reduce #'+ cont)))
	  (t (let ((a (send :future
			    (make-active-instance 'my-vector 
			    :content (subseq cont 0 (floor length 2)))
			  'add-up))
		   (b (send :future 
			    (make-active-instance 'my-vector 
			    :content (subseq cont 
					     (floor length 2)
					     length))
			  'add-up)))
	     (print (+ (touch a) (touch b))))))))


(defmethod par-conc ((v1 my-vector) (v2 my-vector))
  (make-instance 'my-vector 
    :content (concatenate 'vector (content v1) (content v2))))

(defmethod par-conc ((v1 proxy) (v2 t))
  (touch (send :future v1 'par-conc v2)))

(defclass list-handler (active-object distributable-object)
  ()
  (:metaclass distributable-object-class))
              

(defmethod par-reduce ((handler list-handler) (func function) (l list) 
		       &key initial)
  (touch (par-do-reduce  handler func (cons initial l))))

(defmethod par-reduce ((handler list-handler) (func symbol) (l list) 
		       &key initial)
  (touch (par-do-reduce  handler (symbol-function func) (cons initial l))))

(defmethod par-do-reduce ((handler list-handler) func (l list))
  (cond((cddr l)
	(par-do-reduce handler
		       func
		       (loop for x = l then (cddr x)
			   while x
			   collect (send :future
					 (make-instance 'list-handler)
					 'par-do-reduce func 
					 (subseq x 0 2)))))
       ((cdr l) (funcall func (touch (first l)) (touch (second l))))
       (t (touch (first l)))))


#|
(defclass list-handler (active-object)
  ()))

(defpargeneric reduce :future (handler func list) 

(defmethod reduce ((handler list-handler) (reductor function) (list list)) 
  (cond ((> (length list) 2))
	 (reduce handler
		 reductor
		 (loop for sublist = list then (cddr sublist)
		     while (not (endp sublist))
		     collect (reduce (make-instance 'list-handler)
				     reductor 
				     (subseq sublist 0 2)))))
	((= (length list) 2)
	 (funcall reductor (touch (car list)) (touch (cdr list))))
	(t (touch (first list)))))
|#



