;;;-----------------------------------------------------------------------------------
;;; name       : 
;;; description: Why? This code is of course selfdocumenting! Well, ok:
;;;              
;;; notes      :
;;; contact    : me (Michael Trowe)
;;; copyright  :
;;; history    : 
;;; contents   :
;;;-----------------------------------------------------------------------------------
(in-package nc)    
(defclass standard-scheduler ()
  ((obj-proc-pairs :initform () :accessor obj-proc-pairs)))


(defvar *standard-scheduler* (make-instance 'standard-scheduler))

(defmethod notify-scheduler ((sched standard-scheduler) obj)
  (push (cons obj (mp:process-run-function "actor" #'active-loop obj))
	(obj-proc-pairs sched)))

(defmethod remove-object ((sched standard-scheduler) obj)
  (setf (obj-proc-pairs sched) 
    (loop for obj-procs on (obj-proc-pairs sched)
	until (eq (caar obj-procs) obj)
	collect (car obj-procs) into new-obj-proc-list
	finally (progn (when obj-procs
			 (mp:process-kill (cdar obj-procs)))
		       (return (append new-obj-proc-list
				       (cdr obj-procs)))))))

(defmethod active-loop ((obj active-object))
  (loop while (active-test obj)
      do (active-body obj)))

(defmethod active-object-wait ((sched standard-scheduler) obj message-name args)
  (let ((message (find-and-delete (mail-queue obj) (cons message-name args) 
				  :test #'message-match)))
    (if message 
	(apply #'apply-message obj message)
      (progn (mp:with-process-lock ((obj-lock obj))
	       (setf (waiting-pattern obj) (cons message-name args)))
	     (mp:process-wait "actor-wait" #'(lambda() 
					       (not (waiting-pattern obj))))))))










