(in-package nc)


;(defun foo3 () (print 'foo) #>(lambda (x) (+ 3 x)))

(defclass ncl-object (mobile-object active-object)
  ((queue :moving-behavior #'(lambda (queue stream) (print `(mq ,@(all-elements queue)) stream))))
  (:metaclass mobile-object-class))			      
			      
			      


(defclass move-tester (ncl-object)
  ((s1 :accessor s1
       :initarg :s1
       :moving-behavior :stay)
   (s2 :accessor s2
       :initarg :s2
       :moving-behavior :stay)
   (s3 :accessor s3
       :initarg :s3
       :moving-behavior :follow))
  (:metaclass mobile-object-class))

(defpargeneric pg1 :future (tester))

(defmethod pg1 ((tester move-tester)) (sleep 10) (s1 tester))
	       
(defpargeneric pg2 :past (tester val))

(defmethod pg2 ((tester move-tester) val) (setf (s1 tester) val))	       

(defclass move-part ()
  ((s1 :accessor s1
       :initarg :s1
       :moving-behavior :stay))
  (:metaclass  mobile-object-class))







(defun testos (&rest machines)
  (ensure-os)
  (when machines
    (start-virtual-machine  machines :form '(load "~/nc/nclos/sources/test.lisp")))
  (let ((proxy1 (move (make-instance 'move-tester 
			:s1 1 
			:s2 (make-instance 'move-tester)  
			:s3 (make-instance 'move-part))
		      (first (spaces *manager*)))))
    (setf *test* proxy1)))


(defpargeneric test-moving :future (tester))

;;; 1. ohne rekursion
;;; test-moving aufruf auf lokalem objekt
;;; move in test-moving
;;; print geschieht noch lokal
;;; weiteres test-moving ist dann remote
;;; --> lokale Operationen werde trotz moving noch ausgefuehrt
;;; vorsicht, wenn test-moving auf das (lokale) proxy angewandt wird
;;; wird test-moving remote ausgefuehrt, wo ein objekt ist, welches
;;; wieder zurueck gemovt wird!! jedes zweitet test-moving ist damit
;;; wieder lokal!

;;; 2. mit rekursion in possibly-move
;;; --> :caller wird mitgesandt bei test-moving, da caller das objekt
;;;     ist welches mit test-moving aufgerufen wird, d.h. das objekt
;;;     selbst schickt sich die gleiche message nochmal!
;;; wenn test-moving in beiden spaces rekursiv definiert ist
;;; --> endlos!!


;;; 3. Mit test-moving-2 und Slot-value setzen
;;;  --> Parallelarbeit innerhalb eines Objekts!!
;;;  wenn ein Objekt:
#|
a) eine Funktion f1 aufruft, die
i) Sich selbst wegbewegt
ii) eine future gen. Funktion f2 auf sich selbst aufruft, dann
iii) wird diese funktion parallel zu f1 auf dem gleichen objekt aufgerufen
iv)  bei slotaenderungen wird der wert der letzten funktion gesetzt.
(vgl. loop 100 --> polk2
      loop 10000 --> polk4)

==> Mails (gen. Funkt) auf eine Objekt sind nicht immer in der gleichen
reihenfolge!!! (d.h. mail-queue wird nicht gemovet!!)

Durch Aufruf einer future gen. Funktion oder auch now und past wird
ein LWP erzeugt (ein ACL Prozess), wenn in diesem eine weitere gen. Funktion
aufgerufen wird, wird ein weiterer prozess erzeugt, wenn das objekt remote 
ist. 

Wenn ein Proxy vorliegt, wird der prozess im anderen objektspace erzeugt,
wenn actives objekt, dann im lokalen! (process-run-function) der weitere 
aufruf einer gen. funnktion wird im gleichen lokalen process durchgefuehrt!

im obigem fall liegen damit zwei processes fuer ein actives objekt vor 
(das active objekt wurde gemovet)



|#

(defmethod test-moving ((tester move-tester))
  (print "hey")
  (setf (s1 tester) 'polk)
  (possibly-move tester)
  (print-it)
  (setf (s1 tester) 'polk2))


(defpargeneric test-moving-2 :future (tester))

(defmethod test-moving-2 ((tester move-tester))
  (print "hey")
  (setf (s1 tester) 'polk3)
  (loop for i from 0 to 100000 do nil)
  (print-it)
  (setf (s1 tester) 'polk4))

(defun print-it ()
  (loop for i from 0 to 10 do (print i)))

(defun possibly-move (tester)
  (print "POSS")
  (when (not (typep (class-of tester) 'proxy-class))
    (print "NOT Proxy")
    (move tester (first (spaces *manager*)))
    ;;;(test-moving tester) ;;  hier diverse varianten (s.o.)
    (test-moving-2 tester)
    
    ))

(defmethod test-printing ((tester move-tester))
  (print "hey")
  (loop for i from 0 to 10 do (print i)))

(defpargeneric test-printing-fut :future (tester))

(defmethod test-printing-fut ((tester move-tester))
  (print "hey")
  (loop for i from 0 to 10 do (print i)))

(defpargeneric test-printing-fut-2 :future (tester))

(defmethod test-printing-fut-2 ((tester move-tester))
  (test-printing-fut tester)
  (print "hey 2")
  (loop for i from 11 to 20 do (print i)))

#|

(defgeneric remfoo (tester1 tester2)
  (:generic-function-class ncl-gf))

(defmethod remfoo ((t1 move-tester) (t2 move-tester))
  (let ((help (s1 t1)))
    (setf (s1 t1) (s1 t2))
    (setf (s1 t2) help)))



(defclass space-tester (active-object) ())

(defpargeneric create-lots-of-proxies :future (tester lots))

(defmethod create-lots-of-proxies ((tester space-tester) lots)
  (loop for x from 1 upto lots
      do (make-instance 'move-tester :s1 x :location (first (spaces *manager*)))))

(defvar *log* '(0))

(defmethod kernel-send :around ((objspace objspace) mes)
  (push (1+ (car *log*)) *log*)
  (call-next-method)
  (push (1- (car *log*)) *log*))

(defpargeneric send-very-long-message :future (tester long))

(defmethod send-very-long-message ((tester space-tester) long)
  (remote-eval (first (spaces *manager*)) (compose-long-message long)))

(defun compose-long-message (long)
  (when (> long 0)
  (list 'cons
	(compose-long-message (1- long))
	(list 'cons :qwert (compose-long-message (1- long))))))
				      

(defclass proxy-dispatching-gf (standard-generic-function)
  ()
  (:metaclass clos:funcallable-standard-class))

(defclass proxy () 
	 ((master-class-name :accessor master-class-name 
			     :initarg :master-class-name)))

(defmethod clos:compute-applicable-methods-using-classes ((gf proxy-dispatching-gf) classes)
  (if (loop for class in classes
	  thereis (eq (class-name class) 'proxy))
      (values nil nil)
    (call-next-method)))

(defmethod compute-applicable-methods ((gf proxy-dispatching-gf) arguments)
  (let* ((proxyp)
	 (classes (loop with proxy-class = (find-class 'proxy)
		       for arg in arguments
		       collect (if (eq (class-of arg)
				       proxy-class)
				   (progn (setf proxyp t)
					  (find-class (master-class-name arg)))
				 (class-of arg)))))
    (if proxyp
	(multiple-value-bind (method-list success)
	    (clos:compute-applicable-methods-using-classes gf classes)
	  (if success
	      method-list
	    (call-next-method)))
      (call-next-method))))

(defclass foo () ())

(defgeneric bar (x y) (:generic-function-class proxy-dispatching-gf))

(defmethod bar (x y) (format t "the general method was used"))

(defmethod bar ((x c2) (y c2)) (format t "the special method was used"))

(setf f (make-instance 'c2))

(setf p (make-instance 'proxy :master-class-name 'foo))

(bar 1 2)

(bar f f)

(Bar f p)

(clos:compute-applicable-methods-using-classes (ensure-generic-function 'bar)
					      (list (find-class 'foo) 
						    (find-class 'proxy)))
 

(compute-applicable-methods (ensure-generic-function 
			     'bar)
			    (list f p))


|#






